package org.zipcoder.store;

import java.util.ArrayList;
import java.util.List;

public class ListMap implements MyMap {
    // instance field that is intialize to an ArrayList
    private List<Entry> entries = new ArrayList<>();

    @Override
    public int size() {
        return entries.size();
    }

    @Override
    public boolean isEmptry() { return entries.isEmpty(); }

    @Override
    public Cart get(User key) {
        // find the cart associate with the key
        Cart rightCart = null;
        for (Entry entry : entries) {
            if (entry.getKey() == key) {
                rightCart = entry.getValue();
            }
        }
        return rightCart;
    }

    @Override
    public void put(User key, Cart value) {
        // add the key, value entry to the entries list
        Entry entry = new Entry(key, value);
        entries.add(entry);
    }


    @Override
    public List<User> getKeys() {
        // get all the keys in the map
        List<User> keys = new ArrayList<>();
        entries.forEach(entry -> keys.add(entry.getKey()));
//        for (Entry entry : entries) {
//            keys.add(entry.getKey());
//        }
        return keys;
    }

    @Override
    public List<Cart> getValues() {
        // get all the values in the map
        List<Cart> values = new ArrayList<>();
        entries.forEach(entry -> values.add(entry.getValue()));
        return values;
    }

    @Override
    public Cart remove(User key) {
        Cart rightValue = null;
        for (Entry entry : entries) {
            if (entry.getKey() == key) {
                rightValue = entry.getValue();
                entries.remove(entry);
            }
        }
        return rightValue;
    }
}
