package org.zipcoder.store;

import java.util.*;

public class MyHashMap implements MyMap{
    // final field that doesn't change for any object
    private static final int BUCKET_SIZE = 15;

    // instance field that can only be set once. It is different for every Object
    private final List<Entry>[] entries;
    private int size;

    public MyHashMap(){
    // creates an array of length 15
        entries = new List[BUCKET_SIZE];
    // populates array with 15 ArrayLists
        for(int i = 0; i < BUCKET_SIZE; i++) {
            entries[i] = new ArrayList<>();
        }
    }

    @Override
    public int size() {
        for (int i = 0; i < entries.length; i++) {
            size += entries[i].size();
        }
        return size;
    }

    @Override
    public boolean isEmptry() {
        return size == 0;
    }

    @Override
    public Cart get(User key) {
        Cart rightCart = null;
        for (List<Entry> e : entries) {
            for (Entry entry : e) {
                if(entry.getKey().equals(key) || entry.getKey().getName().equals(key.getName())) {
                    rightCart = entry.getValue();
                }
            }
        }
        return rightCart;
    }

    @Override
    public void put(User key, Cart value) {
        Entry entry = new Entry(key, value);
        entries[this.size++].add(entry);
        //this.size++;
    }

    @Override
    public List<User> getKeys() {
        List<User> keyList = new ArrayList<>();
        List<List<Entry>> lambdaList = new ArrayList<>(Arrays.asList(entries));

        lambdaList.forEach(entries1 -> entries1.forEach(entry -> keyList.add(entry.getKey())));
        return keyList;
    }

    @Override
    public List<Cart> getValues() {
        List<Cart> valueList = new ArrayList<>();
        List<List<Entry>> lambdaList = new ArrayList<>(Arrays.asList(entries));

        lambdaList.forEach(entries1 -> entries1.forEach(entry -> valueList.add(entry.getValue())));
        return valueList;
    }

    @Override
    public Cart remove(User key) {
        Cart rightCart = null;
        for (List<Entry> list : entries) {
            for (Entry entry : list) {
                if (entry.getKey() == key) {
                    rightCart = entry.getValue();
                }
            }
        }
        return rightCart;
    }

    private int bucketIndex(User key){
        return Math.abs(key.hashCode()) % entries.length;
    }
}
